# std::is_volatile

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_volatile; |  | (since C++11)

If `T` is a volatile-qualified type (that is, volatile, or const volatile), provides the member constant `value` equal true. For any other type, `value` is false.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_volatile_v = is_volatile<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is a volatile-qualified type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant <bool, value>

### Possible implementation

    template<class T> struct is_volatile             : std::false_type {};
    template<class T> struct is_volatile<volatile T> : std::true_type {};

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_volatile<int>::value << '\n';
        std::cout << std::is_volatile<volatile int>::value  << '\n';
    }

Output:

    false
    true

### See also

is_const (C++11) | checks if a type is const-qualified (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/types/is_volatile&oldid=91006"